package be.jeffcheasey88.peeratcode;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.sql.Connection;

import be.jeffcheasey88.peeratcode.repository.DatabaseRepository;

public class TestDatabaseRepository extends DatabaseRepository{

	private Connection con;
	private String schem;
	
	public TestDatabaseRepository(Configuration config, File databaseSchem){
		super(config);
		
		try{
			schem = "";
			BufferedReader reader = new BufferedReader(new FileReader(databaseSchem));
			String line;
			while((line = reader.readLine()) != null) schem+=line+"\n";
			reader.close();
		}catch(Exception e){
			e.printStackTrace();
		}
	}

	public void init(){
		try {
			Method method = DatabaseRepository.class.getDeclaredMethod("ensureConnection");
			method.setAccessible(true);
			method.invoke(this);
			
			Field field = DatabaseRepository.class.getDeclaredField("con");
			field.setAccessible(true);
			this.con = (Connection) field.get(this);
		}catch(Exception e){
			e.printStackTrace();
			System.out.println(e.getCause());
		}
	}
	
	public void reset(){
		try{
			this.con.prepareStatement(schem).execute();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
}
