package be.jeffcheasey88.peeratcode.userstories;

import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestInstance;
import org.junit.jupiter.api.TestInstance.Lifecycle;

import be.jeffcheasey88.peeratcode.Main;
import be.jeffcheasey88.peeratcode.WebClient;

@TestInstance(Lifecycle.PER_METHOD)
public class RegisterTests extends BaseUserStoriesTest{
	
	private Thread server;
	private WebClient client;
	
	@BeforeEach
	public void init(){
		super.init();
		getRepository().init();
		getRepository().reset();
		
		server = new Thread(new Runnable(){
			@Override
			public void run(){
				try {
					Main.main(null);
				} catch (Exception e){
					e.printStackTrace();
				};
			}
		});
		server.start();
		client = new WebClient("localhost", 80);
	}
	
	@AfterEach
	public void stop(){
		server.interrupt();
	}
	
	@Test
	public void normalRegister() throws Exception{
		client.register("test", "test", "test@peerat.dev", "te", "st", "my desc");
		client.assertResponseCode(200);
	}
	
	@Test
	public void pseudoAlreadyUse(){
		
	}
	
	@Test
	public void emailAlreadyUse(){
		
	}
	
	@Test
	public void emptyField(){
		
	}
	
	@Test
	public void lostField(){
		
	}
	
	@Test
	public void alreadyLoggedin(){
		
	}
}
